# M&C Python client include file for vitisAccelCore FPGA
# Note that this file uses register (not AXI byte) addresses and offsets
FPGAMAP = {
    "ct_atomic_pst_in": {
        "slaves": {
            "config": {
                "fields": {
                    "active_table": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Which table is currently used by the corner turn? Do not change contents of that table unless in reset.",
                        "start": 9234,
                        "step": 1,
                        "stop": 9235,
                        "width": 1,
                    },
                    "buffer_enable": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 15,
                        "description": "One bit to enable each of the 4 buffers. At least 3 buffers must be enabled for correct functioning of the corner turn. This can be changed at any time. These bits do not prevent buffers from being read out, "
                        "they only prevent the buffer from being selected as the next buffer to write to.The purpose of these bits is to allow the host to download LFAA data.",
                        "start": 9225,
                        "step": 1,
                        "stop": 9226,
                        "width": 4,
                    },
                    "control_enable_timed_output": {
                        "access_mode": "RW",
                        "bit_offset": 1,
                        "default": 0,
                        "description": "New value only applied on reset: use walltime to regulate output.If 0, then buffers are output based on receiving packets for the next buffer.See the untimed_framecount_start register.",
                        "start": 9231,
                        "step": 1,
                        "stop": 9232,
                        "width": 1,
                    },
                    "control_use_new_config": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Toggle this bit from 0 to 1 to make the CTC use the parameters above after they have been set. Note new parameters are also loaded at a full reset.",
                        "start": 9231,
                        "step": 1,
                        "stop": 9232,
                        "width": 1,
                    },
                    "duplicates": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Count of duplicate input packets (i.e. input packets with the same timestamp and channel as a previous packet). Top bit is sticky.",
                        "start": 9240,
                        "step": 1,
                        "stop": 9241,
                        "width": 8,
                    },
                    "error_ctc_underflow": {
                        "access_mode": "RO",
                        "bit_offset": 1,
                        "default": 0,
                        "description": "Readout was triggered, but the data FIFO does not contain enough data to start output",
                        "start": 9242,
                        "step": 1,
                        "stop": 9243,
                        "width": 1,
                    },
                    "error_input_overflow": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "input buffer has overflowed.",
                        "start": 9242,
                        "step": 1,
                        "stop": 9243,
                        "width": 1,
                    },
                    "frame_count_buffer0": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "frame count for the first packet in buffer 0.",
                        "start": 9227,
                        "step": 1,
                        "stop": 9228,
                        "width": 32,
                    },
                    "frame_count_buffer1": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "frame count for the first packet in buffer 1.",
                        "start": 9228,
                        "step": 1,
                        "stop": 9229,
                        "width": 32,
                    },
                    "frame_count_buffer2": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "frame count for the first packet in buffer 2.",
                        "start": 9229,
                        "step": 1,
                        "stop": 9230,
                        "width": 32,
                    },
                    "frame_count_buffer3": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "frame count for the first packet in buffer 3.",
                        "start": 9230,
                        "step": 1,
                        "stop": 9231,
                        "width": 32,
                    },
                    "full_reset": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Start or restart corner turn after (re)configuring it.",
                        "start": 9216,
                        "step": 1,
                        "stop": 9217,
                        "width": 1,
                    },
                    "halt_packet_count": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "At which packet count shall the corner turn stop? (0 means never)",
                        "start": 9218,
                        "step": 1,
                        "stop": 9219,
                        "width": 32,
                    },
                    "input_late_count": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Number of input LFAA blocks which have been dropped as they are too late. Top bit is sticky.",
                        "start": 9238,
                        "step": 1,
                        "stop": 9239,
                        "width": 16,
                    },
                    "input_too_soon_count": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Count of input LFAA blocks which have been dropped as they are too far into the future. Top bit is sticky.",
                        "start": 9239,
                        "step": 1,
                        "stop": 9240,
                        "width": 16,
                    },
                    "maxfuturecount": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 256,
                        "description": "Maximum distance into the future that a packet count can be before we drop it as being too far into the future. Units 2.2ms (i.e. one 2048 sample LFAA input packet)",
                        "start": 9219,
                        "step": 1,
                        "stop": 9220,
                        "width": 16,
                    },
                    "missing_blocks": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Count of blocks (1 block = 2048 time samples) on the PSS/PST read out with no data; top bit is sticky; low 15 bits wrap.",
                        "start": 9241,
                        "step": 1,
                        "stop": 9242,
                        "width": 16,
                    },
                    "output_cycles": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 86,
                        "description": "Number of clock cycles from the start of one output packet to the start of the next packet.Actual packet length is 64 clocks. Default is 86, which assumes a 450 MHz PSS/PST output clock.",
                        "start": 9224,
                        "step": 1,
                        "stop": 9225,
                        "width": 16,
                    },
                    "packet_count": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "The selected coarse delay table changes if the packet count >= this value. Leaving this at 0 will switch ASAP.",
                        "start": 9232,
                        "step": 1,
                        "stop": 9233,
                        "width": 32,
                    },
                    "preload": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 2816,
                        "description": "Number samples for the preload for the PSS/PST output. The PST filterbank has 12 taps and a 256 point FFT, so 11 tap preload is required, corresponding to 11*256 samples.",
                        "start": 9221,
                        "step": 1,
                        "stop": 9222,
                        "width": 16,
                    },
                    "psspst_output_count": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Number of valid input blocks read for each channel.",
                        "start": 8192,
                        "step": 1,
                        "stop": 9216,
                        "width": 32,
                    },
                    "reset": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Reset all monitoring (takes 1024 cycles to complete).",
                        "start": 9237,
                        "step": 1,
                        "stop": 9238,
                        "width": 1,
                    },
                    "running": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Is the corner turn running, i.e. are we between starting_packet_count and halt_packet_count?",
                        "start": 9217,
                        "step": 1,
                        "stop": 9218,
                        "width": 1,
                    },
                    "scanstartpacketcount": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Packet count to start the scan at. LFAA data with a packet count less than this value will be dropped.",
                        "start": 9220,
                        "step": 1,
                        "stop": 9221,
                        "width": 32,
                    },
                    "starting_wall_time_nanos": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "When will the first packet output from the CTC? (wall time nano seconds)",
                        "start": 9223,
                        "step": 1,
                        "stop": 9224,
                        "width": 32,
                    },
                    "starting_wall_time_seconds": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "When will the first packet output from the CTC? (wall time seconds)",
                        "start": 9222,
                        "step": 1,
                        "stop": 9223,
                        "width": 32,
                    },
                    "table0_startpacket": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Packet count that the fine delay values in table_0 are referenced to. The fine delay that is applied to the output of the filterbank is based on the sample count of the first sample used to generate that "
                        "output. Note that the FIR filter used in the filterbank creates an offset between the time of the first sample that contributes to a filterbank output and the time stamp for the filterbank output, "
                        "typically equal to half the length of the FIR filter.",
                        "start": 9235,
                        "step": 1,
                        "stop": 9236,
                        "width": 32,
                    },
                    "table1_startpacket": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Packet count that the fine delay values in table_1 are referenced to. See the description of table0_startPacket.",
                        "start": 9236,
                        "step": 1,
                        "stop": 9237,
                        "width": 32,
                    },
                    "table_0": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Coarse and fine delay values - Table 0. Each virtual channel C has 4 words, at addresses 4C, 4C+1, 4C+2, 4C+3. Word 0, bits 10:0 = Coarse Delay, bits 31:16 = Hpol DeltaP. Word 1, bits 15:0 = Vpol DeltaP, bits 31:16 "
                        "= DeltaDelta P (common to both polarisations).Word 2, bits 15:0 = Hpol phase offset for the center frequency, bits(31:16) = Vpol phase offset for the center frequency. Word 3, bits 31:0 = step in the phase offset "
                        "for the center frequency per output packet. This is common to both polarisations. See confluence documentation for details.",
                        "start": 0,
                        "step": 1,
                        "stop": 4096,
                        "width": 32,
                    },
                    "table_1": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Coarse delay values - Table 1. As per the definition for table_0.",
                        "start": 4096,
                        "step": 1,
                        "stop": 8192,
                        "width": 32,
                    },
                    "table_select": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Defines which table should become active when the given packet_count is passed",
                        "start": 9233,
                        "step": 1,
                        "stop": 9234,
                        "width": 1,
                    },
                    "untimed_framecount_start": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 1,
                        "description": "Used in untimed mode only.Reading of a buffer will start when a packet count with this offset within a buffer or greater is received for the next buffer.",
                        "start": 9226,
                        "step": 1,
                        "stop": 9227,
                        "width": 16,
                    },
                },
                "start": 0,
                "step": 9243,
                "stop": 9243,
                "type": "REG",
            }
        },
        "start": 81920,
        "step": 9243,
        "stop": 91163,
    },
    "ct_atomic_pst_out": {
        "slaves": {
            "statctrl": {
                "fields": {
                    "beamsenabled": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Number of PST beams currently enabled.",
                        "start": 11,
                        "step": 1,
                        "stop": 12,
                        "width": 8,
                    },
                    "bfjonesselect": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Selects which of the two Jones Matrices buffers to use in the beamformers. This is applied when the packet count reaches the value in the register packetCountBFJonesSwitch.",
                        "start": 7,
                        "step": 1,
                        "stop": 8,
                        "width": 1,
                    },
                    "bfphaseselect": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Selects which of the two Jones Matrices buffers to use in the beamformers. This is applied when the packet count reaches the value in the register packetCountBFPhaseSwitch.",
                        "start": 9,
                        "step": 1,
                        "stop": 10,
                        "width": 1,
                    },
                    "bufferenable": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 15,
                        "description": "1 bit to enable each of the 4 blocks of 256 MBytes of HBM. Each 256 MBytes of HBM is a single output buffer.",
                        "start": 2,
                        "step": 1,
                        "stop": 3,
                        "width": 4,
                    },
                    "bufferoverflowerror": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Write buffer used to transfer filterbank data into the HBM overflowed. Cleared by a reset in the first stage corner turn. Should never happen.",
                        "start": 0,
                        "step": 1,
                        "stop": 1,
                        "width": 1,
                    },
                    "hbmbuf0packetcount": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "LFAA packet count for the first packet in HBM buffer 0",
                        "start": 3,
                        "step": 1,
                        "stop": 4,
                        "width": 32,
                    },
                    "hbmbuf1packetcount": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "LFAA packet count for the first packet in HBM buffer 1",
                        "start": 4,
                        "step": 1,
                        "stop": 5,
                        "width": 32,
                    },
                    "hbmbuf2packetcount": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "LFAA packet count for the first packet in HBM buffer 2",
                        "start": 5,
                        "step": 1,
                        "stop": 6,
                        "width": 32,
                    },
                    "hbmbuf3packetcount": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "LFAA packet count for the first packet in HBM buffer 3",
                        "start": 6,
                        "step": 1,
                        "stop": 7,
                        "width": 32,
                    },
                    "numberofbeams": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Number of PST beams supported by this firmware build",
                        "start": 12,
                        "step": 1,
                        "stop": 13,
                        "width": 8,
                    },
                    "packetcountbfjonesswitch": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Packet count at which to switch the buffer to use for the beamformer Jones Matrices. Use zero to switch at the next frame.",
                        "start": 8,
                        "step": 1,
                        "stop": 9,
                        "width": 32,
                    },
                    "packetcountbfphaseswitch": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Packet count at which to switch the buffer to use for the beamformer phase tracking. Use zero to switch at the next frame.",
                        "start": 10,
                        "step": 1,
                        "stop": 11,
                        "width": 32,
                    },
                    "readinallclocks": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Interval between the start of one frame and the start of the next frame in units of 300 MHz clocks at the input to the corner turn.",
                        "start": 14,
                        "step": 1,
                        "stop": 15,
                        "width": 32,
                    },
                    "readinclocks": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Length of the most recent frame in units of 300 MHz clocks at the input to the corner turn.",
                        "start": 13,
                        "step": 1,
                        "stop": 14,
                        "width": 32,
                    },
                    "readoutclocks": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Length of the most recent frame in units of 400 MHz clocks at the output of the corner turn",
                        "start": 15,
                        "step": 1,
                        "stop": 16,
                        "width": 32,
                    },
                    "readouterror": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Readout to the beamformer did not finish before the readout of the next HBM buffer started. Cleared by a reset passed in from the first stage corner turn. Should never happen.",
                        "start": 1,
                        "step": 1,
                        "stop": 2,
                        "width": 1,
                    },
                },
                "start": 0,
                "step": 16,
                "stop": 16,
                "type": "REG",
            }
        },
        "start": 212992,
        "step": 16,
        "stop": 213008,
    },
    "drp": {
        "slaves": {
            "cmac_drp_interface": {
                "fields": {
                    "cmac_drp_addr_base": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Address to read from",
                        "start": 1,
                        "step": 1,
                        "stop": 2,
                        "width": 10,
                    },
                    "cmac_drp_return_value": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Data from DRP interface",
                        "start": 2,
                        "step": 1,
                        "stop": 3,
                        "width": 16,
                    },
                    "cmac_drp_sm_control_vector": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Definitions below, each action will take several cycles at 100MhZ, don't hammer!!!, Bit 0 - Perform Action, set 1, wait for DRP return value to update before de-asserting and setting up next "
                        "instruction Bit 1 - perform read = 0, write = 1 (performing a write will trigger a read to verify) ",
                        "start": 0,
                        "step": 1,
                        "stop": 1,
                        "width": 16,
                    },
                    "cmac_drp_value_to_write": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Data to write to DRP interface.",
                        "start": 3,
                        "step": 1,
                        "stop": 4,
                        "width": 16,
                    },
                    "cmac_stat_reset": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Clears all stat counters.",
                        "start": 15,
                        "step": 1,
                        "stop": 16,
                        "width": 8,
                    },
                    "cmac_stat_rx_bad_code": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for packets shorter than min packet length with bad FCS.",
                        "start": 41,
                        "step": 1,
                        "stop": 42,
                        "width": 32,
                    },
                    "cmac_stat_rx_bad_preamble": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for packets shorter than min packet length with bad FCS.",
                        "start": 43,
                        "step": 1,
                        "stop": 44,
                        "width": 32,
                    },
                    "cmac_stat_rx_bad_sfd": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for packets shorter than min packet length with bad FCS.",
                        "start": 42,
                        "step": 1,
                        "stop": 43,
                        "width": 32,
                    },
                    "cmac_stat_rx_broadcast": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for good broadcast packets.",
                        "start": 36,
                        "step": 1,
                        "stop": 37,
                        "width": 32,
                    },
                    "cmac_stat_rx_fragment": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for packets shorter than min packet length with bad FCS.",
                        "start": 40,
                        "step": 1,
                        "stop": 41,
                        "width": 32,
                    },
                    "cmac_stat_rx_multicast": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for good multicast packets.",
                        "start": 35,
                        "step": 1,
                        "stop": 36,
                        "width": 32,
                    },
                    "cmac_stat_rx_oversize": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for packets longer than ctl_rx_max_packet_len with good FCS.",
                        "start": 37,
                        "step": 1,
                        "stop": 38,
                        "width": 32,
                    },
                    "cmac_stat_rx_packet_1024_1518_bytes": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for good and bad packets received that contain 1024 to 1518 bytes.",
                        "start": 25,
                        "step": 1,
                        "stop": 26,
                        "width": 32,
                    },
                    "cmac_stat_rx_packet_128_255_bytes": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for good and bad packets received that contain 128 to 255 bytes.",
                        "start": 22,
                        "step": 1,
                        "stop": 23,
                        "width": 32,
                    },
                    "cmac_stat_rx_packet_1519_1522_bytes": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for good and bad packets received that contain 1519 to 1522 bytes.",
                        "start": 26,
                        "step": 1,
                        "stop": 27,
                        "width": 32,
                    },
                    "cmac_stat_rx_packet_1523_1548_bytes": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for good and bad packets received that contain 1523 to 1548 bytes.",
                        "start": 27,
                        "step": 1,
                        "stop": 28,
                        "width": 32,
                    },
                    "cmac_stat_rx_packet_1549_2047_bytes": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for good and bad packets received that contain 1549 to 2047 bytes.",
                        "start": 28,
                        "step": 1,
                        "stop": 29,
                        "width": 32,
                    },
                    "cmac_stat_rx_packet_2048_4095_bytes": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for good and bad packets received that contain 2048 to 4095 bytes.",
                        "start": 29,
                        "step": 1,
                        "stop": 30,
                        "width": 32,
                    },
                    "cmac_stat_rx_packet_256_511_bytes": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for good and bad packets received that contain 256 to 511 bytes.",
                        "start": 23,
                        "step": 1,
                        "stop": 24,
                        "width": 32,
                    },
                    "cmac_stat_rx_packet_4096_8191_bytes": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for good and bad packets received that contain 4096 to 8191 bytes.",
                        "start": 30,
                        "step": 1,
                        "stop": 31,
                        "width": 32,
                    },
                    "cmac_stat_rx_packet_512_1023_bytes": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for good and bad packets received that contain 512 to 1023 bytes.",
                        "start": 24,
                        "step": 1,
                        "stop": 25,
                        "width": 32,
                    },
                    "cmac_stat_rx_packet_64_bytes": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for good and bad packets received that contain 64 bytes.",
                        "start": 20,
                        "step": 1,
                        "stop": 21,
                        "width": 32,
                    },
                    "cmac_stat_rx_packet_65_127_bytes": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for good and bad packets received that contain 65 to 127 bytes.",
                        "start": 21,
                        "step": 1,
                        "stop": 22,
                        "width": 32,
                    },
                    "cmac_stat_rx_packet_8192_9215_bytes": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for good and bad packets received that contain 8192 to 9215 bytes.",
                        "start": 31,
                        "step": 1,
                        "stop": 32,
                        "width": 32,
                    },
                    "cmac_stat_rx_packet_bad_fcs": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for packets between 64 and max length that have FCS errors.",
                        "start": 19,
                        "step": 1,
                        "stop": 20,
                        "width": 32,
                    },
                    "cmac_stat_rx_packet_large": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for packets more than 9215 bytes long.",
                        "start": 33,
                        "step": 1,
                        "stop": 34,
                        "width": 32,
                    },
                    "cmac_stat_rx_packet_small": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for packets less than 64 bytes long.",
                        "start": 32,
                        "step": 1,
                        "stop": 33,
                        "width": 32,
                    },
                    "cmac_stat_rx_toolong": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for packets longer than ctl_rx_max_packet_len with good and bad FCS.",
                        "start": 38,
                        "step": 1,
                        "stop": 39,
                        "width": 32,
                    },
                    "cmac_stat_rx_total_good_packets": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for total number of good packets, ie no errors.",
                        "start": 18,
                        "step": 1,
                        "stop": 19,
                        "width": 32,
                    },
                    "cmac_stat_rx_total_packets": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for total number of packets received.",
                        "start": 17,
                        "step": 1,
                        "stop": 18,
                        "width": 32,
                    },
                    "cmac_stat_rx_undersize": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for packets shorter than min packet length with good FCS.",
                        "start": 39,
                        "step": 1,
                        "stop": 40,
                        "width": 32,
                    },
                    "cmac_stat_rx_unicast": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for good unicast packets.",
                        "start": 34,
                        "step": 1,
                        "stop": 35,
                        "width": 32,
                    },
                    "cmac_stat_tx_total_packets": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Increment for total number of packets received.",
                        "start": 16,
                        "step": 1,
                        "stop": 17,
                        "width": 32,
                    },
                    "gt_0_drp_return_value": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Data from DRP interface",
                        "start": 6,
                        "step": 1,
                        "stop": 7,
                        "width": 16,
                    },
                    "gt_0_drp_value_to_write": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Data to write to DRP interface.",
                        "start": 10,
                        "step": 1,
                        "stop": 11,
                        "width": 16,
                    },
                    "gt_1_drp_return_value": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Data from DRP interface",
                        "start": 7,
                        "step": 1,
                        "stop": 8,
                        "width": 16,
                    },
                    "gt_1_drp_value_to_write": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Data to write to DRP interface.",
                        "start": 11,
                        "step": 1,
                        "stop": 12,
                        "width": 16,
                    },
                    "gt_2_drp_return_value": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Data from DRP interface",
                        "start": 8,
                        "step": 1,
                        "stop": 9,
                        "width": 16,
                    },
                    "gt_2_drp_value_to_write": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Data to write to DRP interface.",
                        "start": 12,
                        "step": 1,
                        "stop": 13,
                        "width": 16,
                    },
                    "gt_3_drp_return_value": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Data from DRP interface",
                        "start": 9,
                        "step": 1,
                        "stop": 10,
                        "width": 16,
                    },
                    "gt_3_drp_value_to_write": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Data to write to DRP interface.",
                        "start": 13,
                        "step": 1,
                        "stop": 14,
                        "width": 16,
                    },
                    "gt_drp_addr_base": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Address to read from",
                        "start": 5,
                        "step": 1,
                        "stop": 6,
                        "width": 10,
                    },
                    "gt_drp_sm_control_vector": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Definitions below, each action will take several cycles at 100MhZ, don't hammer!!!, Bit 0 - Perform Action, set 1, wait for DRP return value to update before de-asserting and setting up next "
                        "instruction Bit 1 - GT lane 0 perform read = 0, write = 1 (performing a write will trigger a read to verify) Bit 2 - GT lane 1 perform read = 0, write = 1 (performing a write will trigger a read to "
                        "verify) Bit 3 - GT lane 2 perform read = 0, write = 1 (performing a write will trigger a read to verify) Bit 4 - GT lane 3 perform read = 0, write = 1 (performing a write will trigger a read to "
                        "verify) ",
                        "start": 4,
                        "step": 1,
                        "stop": 5,
                        "width": 16,
                    },
                    "rx_equaliser_settings": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Bit 0 is used to select between DFE and LPM settings, the next 7 bits can be used for Insertion loss figure.",
                        "start": 14,
                        "step": 1,
                        "stop": 15,
                        "width": 16,
                    },
                },
                "start": 0,
                "step": 44,
                "stop": 44,
                "type": "REG",
            }
        },
        "start": 8404992,
        "step": 44,
        "stop": 8405036,
    },
    "filterbanks": {
        "slaves": {
            "firtaps": {
                "fields": {
                    "data": {
                        "access_mode": "RW",
                        "bit_offset": 32,
                        "default": 0,
                        "description": "Filterbank FIR taps. Address 0-49151 = Correlator FIR filter, 49152-5223 = PST FIR filter, 53248-54015 = PSS FIR filter.",
                        "start": 0,
                        "step": 1,
                        "stop": 65536,
                        "width": 32,
                    }
                },
                "start": 0,
                "step": 65536,
                "stop": 65536,
                "type": "RAM",
            }
        },
        "start": 131072,
        "step": 65536,
        "stop": 196608,
    },
    "lfaadecode100g": {
        "slaves": {
            "statctrl": {
                "fields": {
                    "badethernetframes": {
                        "access_mode": "CS",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Count of ethernet packets with errors (e.g. too short, too long, or FCS bad), reset on write.",
                        "start": 1030,
                        "step": 1,
                        "stop": 1031,
                        "width": 16,
                    },
                    "badipudpframes": {
                        "access_mode": "CS",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Count of ethernet packets with bad IP or UDP checksums, reset on write.",
                        "start": 1031,
                        "step": 1,
                        "stop": 1032,
                        "width": 16,
                    },
                    "control": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "bit 0 rising edge resets the module.",
                        "start": 1024,
                        "step": 1,
                        "stop": 1025,
                        "width": 1,
                    },
                    "nonspead_packet_count": {
                        "access_mode": "CS",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Count of non-LFAA SPEAD packets received, 32 bit saturating, reset on write.",
                        "start": 1029,
                        "step": 1,
                        "stop": 1030,
                        "width": 16,
                    },
                    "novirtualchannelcount": {
                        "access_mode": "CS",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Count of packets that did not match an entry in the virtual channel table, reset on write.",
                        "start": 1032,
                        "step": 1,
                        "stop": 1033,
                        "width": 16,
                    },
                    "spead_packet_count": {
                        "access_mode": "CW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Count of LFAA SPEAD packets received, 32 bit wrapping, reset on write.",
                        "start": 1028,
                        "step": 1,
                        "stop": 1029,
                        "width": 32,
                    },
                    "total_channels": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Total number of virtual channels to process in this FPGA. Should be total_stations * total_coarse.",
                        "start": 1027,
                        "step": 1,
                        "stop": 1028,
                        "width": 16,
                    },
                    "total_coarse": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Total number of coarse channels to process in this FPGA.",
                        "start": 1026,
                        "step": 1,
                        "stop": 1027,
                        "width": 16,
                    },
                    "total_stations": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Number of different stations to process in this FPGA.",
                        "start": 1025,
                        "step": 1,
                        "stop": 1026,
                        "width": 16,
                    },
                    "vctable": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Virtual channel table. Each entry has bits(8:0) = frequency_id, bits(12:9) = beam_id, bits(15:13) = substation_id, bits(20:16) = subarray_id, bits(30:21) = station_id, bit(31) = invalid (i.e. set to 1 to indicate "
                        "this entry is invalid).The maximum number of valid entries in this table is defined by total_channels.Used virtual channels must be packed into the lower end of the addresses in the VCTable.For example, if there are "
                        "128 virtual channels, then they must be in entries 0 to 127 of this table.Virtual channels must be sorted first according to station_id, then according to frequency_id. So for example if there are 3 stations with "
                        "ids (5, 10, 12) and 2 channels with ids (100, 101), then they would be listed in this table as 0 - station 5, channel 100 1 - station 10, channel 100 2 - station 12, channel 100 3 - station 5, channel 101 4 - "
                        "station 10, channel 101 5 - station 12, channel 101 Internally, a virtual channel is generated in the range 0 to (total_channels - 1) and a virtual station is generated in the range 0 to (total_stations - 1). ",
                        "start": 0,
                        "step": 1,
                        "stop": 1024,
                        "width": 32,
                    },
                },
                "start": 8192,
                "step": 1033,
                "stop": 9225,
                "type": "REG",
            },
            "vcstats": {
                "fields": {
                    "data": {
                        "access_mode": "RW",
                        "bit_offset": 32,
                        "default": 0,
                        "description": "Status for each virtual channel.",
                        "start": 0,
                        "step": 1,
                        "stop": 8192,
                        "width": 32,
                    }
                },
                "start": 0,
                "step": 8192,
                "stop": 8192,
                "type": "RAM",
            },
        },
        "start": 65536,
        "step": 9225,
        "stop": 74761,
    },
    "packetiser": {
        "slaves": {
            "packetiser_ctrl": {
                "fields": {
                    "control_vector": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Bit 0 - Enable Packetiser - This will load all the variables for Ethernet/UDP/IPv4 etc and Packet Generator (testmode) controls Bit 1 - Enable Packet Generator Bit 2 - Use Packet Generator number of runs "
                        "parameter Bit 3 - Use default values for parameters",
                        "start": 0,
                        "step": 1,
                        "stop": 1,
                        "width": 16,
                    },
                    "stats_packets_rx_sig_proc": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Packets sent to 100G interface",
                        "start": 4,
                        "step": 1,
                        "stop": 5,
                        "width": 32,
                    },
                    "stats_packets_rx_sig_proc_invalid": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Did not receive expected number of bytes from Signal Processing Logic / Test Pattern Gen",
                        "start": 2,
                        "step": 1,
                        "stop": 3,
                        "width": 32,
                    },
                    "stats_packets_rx_sig_proc_valid": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Received expected number of bytes from Signal Processing Logic / Test Pattern Gen",
                        "start": 1,
                        "step": 1,
                        "stop": 2,
                        "width": 32,
                    },
                    "stats_packets_rx_sm_off": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Data sent to Packetiser sent while SM not running, effectively lost data",
                        "start": 3,
                        "step": 1,
                        "stop": 4,
                        "width": 32,
                    },
                },
                "start": 4096,
                "step": 5,
                "stop": 4101,
                "type": "REG",
            },
            "param": {
                "fields": {
                    "data": {
                        "access_mode": "RW",
                        "bit_offset": 32,
                        "default": 0,
                        "description": "One address space as per below, with partial fields assume lower bits used. 0.ethernet_config.dst_mac(31 downto 0) 1.ethernet_config.dst_mac(47 downto 32) 2.ethernet_config.src_mac(31 downto 0) 3.ethernet_config.src_mac(47 "
                        "downto 32) 4.ethernet_config.eth_type 5.ipv4_config.version(31 : 28), ipv4_config.header_length(27 : 24), ipv4_config.type_of_service(23 : 16), ipv4_config.total_length(15 : 0) 6.ipv4_config.id(31 : 16), "
                        "ipv4_config.ip_flags(15 : 13), ipv4_config.fragment_off(12 : 0) 7.ipv4_config.TTL (31 : 24), ipv4_config.protocol (23 : 16), ipv4_config.header_chk_sum (15 : 0) 8.ipv4_config.src_addr 9.ipv4_config.dst_addr "
                        "10.udp_config.src_port(31 : 16), udp_config.dst_port(15 : 0) 11.udp_config.length(31 : 16), udp_config.checksum(15 : 0) 12.PsrPacket_config.packet_sequence_number(63 downto 32) 13.PsrPacket_config.packet_sequence_number(31 "
                        "downto 0) 14.PsrPacket_config.timestamp_attoseconds(63 downto 32) 15.PsrPacket_config.timestamp_attoseconds(31 downto 0) 16.PsrPacket_config.timestamp_seconds 17.PsrPacket_config.channel_seperation "
                        "18.PsrPacket_config.first_channel_frequency(63 downto 32) 19.PsrPacket_config.first_channel_frequency(31 downto 0) 20.PsrPacket_config.scale_1 21.PsrPacket_config.scale_2 22.PsrPacket_config.scale_3 "
                        "23.PsrPacket_config.scale_4 24.PsrPacket_config.first_channel_number 25.PsrPacket_config.channels_per_packet 26.PsrPacket_config.valid_channels_per_packet 27.PsrPacket_config.number_of_time_samples "
                        "28.PsrPacket_config.beam_number 29.PsrPacket_config.magic_word 30.PsrPacket_config.packet_destination 31.PsrPacket_config.data_precision 32.PsrPacket_config.number_of_power_samples_averaged "
                        "33.PsrPacket_config.number_of_time_samples_weight 34.PsrPacket_config.oversampling_ratio_numerator 35.PsrPacket_config.oversampling_ratio_denominator 36.PsrPacket_config.beamformer_version 37.PsrPacket_config.scan_id(63 "
                        "downto 32) 38.PsrPacket_config.scan_id(31 downto 0) 39.PsrPacket_config.offset_1 40.PsrPacket_config.offset_2 41.PsrPacket_config.offset_3 42.PsrPacket_config.offset_4 43.Packet generator number of packets to send 44.Packet "
                        "generator number of cycles between packets, 400 million cycles per second, approx 900 cycles per low packet ADDRESSES 1024-3071 used for redir.",
                        "start": 0,
                        "step": 1,
                        "stop": 4096,
                        "width": 32,
                    }
                },
                "start": 0,
                "step": 4096,
                "stop": 4096,
                "type": "RAM",
            },
        },
        "start": 8388608,
        "step": 4101,
        "stop": 8392709,
    },
    "pstbeamformer": {
        "slaves": {
            "pstbeamformer": {
                "fields": {
                    "data": {
                        "access_mode": "RW",
                        "bit_offset": 32,
                        "default": 0,
                        "description": "Args ignores this for RAMs",
                        "start": 0,
                        "step": 1,
                        "stop": 4194304,
                        "width": 32,
                    }
                },
                "start": 0,
                "step": 4194304,
                "stop": 4194304,
                "type": "RAM",
            }
        },
        "start": 4194304,
        "step": 4194304,
        "stop": 8388608,
    },
    "system": {
        "slaves": {
            "system": {
                "fields": {
                    "args_magic_number": {
                        "access_mode": "SP",
                        "bit_offset": 0,
                        "default": 4184502273,
                        "description": "args magic number for address 0",
                        "start": 0,
                        "step": 1,
                        "stop": 1,
                        "width": 32,
                    },
                    "args_map_build": {
                        "access_mode": "SP",
                        "bit_offset": 0,
                        "default": 554172945,
                        "description": "args map build date & hour",
                        "start": 1,
                        "step": 1,
                        "stop": 2,
                        "width": 32,
                    },
                    "build_date": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Build Date of firmware, Day/Month/Year, readable in HEX, hand coded and not tied to autogeneration currently",
                        "start": 4,
                        "step": 1,
                        "stop": 5,
                        "width": 32,
                    },
                    "eth100g_fec_enable": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Set to 1 to enable FEC, 0 to disable",
                        "start": 16,
                        "step": 1,
                        "stop": 17,
                        "width": 1,
                    },
                    "eth100g_locked": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "100G ethernet is up",
                        "start": 11,
                        "step": 1,
                        "stop": 12,
                        "width": 1,
                    },
                    "eth100g_rx_bad_code": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Total packets received on the 100G ethernet with 64B/66B code violations",
                        "start": 14,
                        "step": 1,
                        "stop": 15,
                        "width": 32,
                    },
                    "eth100g_rx_bad_fcs": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Total packets received on the 100G ethernet with bad FCS since it was reset",
                        "start": 13,
                        "step": 1,
                        "stop": 14,
                        "width": 32,
                    },
                    "eth100g_rx_total_packets": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Total packets received on the 100G ethernet since it was reset",
                        "start": 12,
                        "step": 1,
                        "stop": 13,
                        "width": 32,
                    },
                    "eth100g_tx_total_packets": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Total packets sent on the 100G ethernet since it was reset",
                        "start": 15,
                        "step": 1,
                        "stop": 16,
                        "width": 32,
                    },
                    "firmware_label": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Firmware Label",
                        "start": 8,
                        "step": 1,
                        "stop": 9,
                        "width": 32,
                    },
                    "firmware_major_version": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Major version number",
                        "start": 5,
                        "step": 1,
                        "stop": 6,
                        "width": 16,
                    },
                    "firmware_minor_version": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Minor version number",
                        "start": 6,
                        "step": 1,
                        "stop": 7,
                        "width": 16,
                    },
                    "firmware_patch_version": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Patch version number",
                        "start": 7,
                        "step": 1,
                        "stop": 8,
                        "width": 16,
                    },
                    "firmware_personality": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Firmware function - PST/PSS/ZOOM/CORR",
                        "start": 9,
                        "step": 1,
                        "stop": 10,
                        "width": 32,
                    },
                    "qsfpgty_resets": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Reset 100G ethernet interface",
                        "start": 3,
                        "step": 1,
                        "stop": 4,
                        "width": 1,
                    },
                    "status_clocks_locked": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "All clocks locked",
                        "start": 2,
                        "step": 1,
                        "stop": 3,
                        "width": 1,
                    },
                    "time_uptime": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Number of seconds since programming",
                        "start": 10,
                        "step": 1,
                        "stop": 11,
                        "width": 32,
                    },
                },
                "start": 0,
                "step": 17,
                "stop": 17,
                "type": "REG",
            }
        },
        "start": 0,
        "step": 17,
        "stop": 17,
    },
    "timingcontrola": {
        "slaves": {
            "timing": {
                "fields": {
                    "cur_time_high": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "High 32 bits of the current 64-bit local time.",
                        "start": 6,
                        "step": 1,
                        "stop": 7,
                        "width": 32,
                    },
                    "cur_time_low": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Low 32 bits of the current 64-bit local time. Units of nanoseconds.",
                        "start": 5,
                        "step": 1,
                        "stop": 6,
                        "width": 32,
                    },
                    "fixed_offset": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 16,
                        "description": "Expected offset between the time messages from the timing master and this module due to transmission latency in units of nanoseconds. Unsigned value, with a maximum of 2^24 - 1 = about 16 ms.",
                        "start": 1,
                        "step": 1,
                        "stop": 2,
                        "width": 24,
                    },
                    "frequency_offset": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Frequency offset parameter. This allows for a correction to compensate for the frequency offset in the 300MHz clock used for the local time.Units are parts per billion. Value is signed. Maximum frequency "
                        "offset is +/- 2^19 per 2^32 clocks = +/- 122 ppm.",
                        "start": 2,
                        "step": 1,
                        "stop": 3,
                        "width": 20,
                    },
                    "last_time_offset": {
                        "access_mode": "RO",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Most recent time offset in nanoseconds. Difference between the most recent time from the master and the local time.",
                        "start": 7,
                        "step": 1,
                        "stop": 8,
                        "width": 32,
                    },
                    "mace_time_high": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "High 32 bits of the 64 bit timestamp set by MACE. A Transition on bit(31) indicates that this value should be used to update the internal time, after subtracting off the value in the fixed_offset register.",
                        "start": 4,
                        "step": 1,
                        "stop": 5,
                        "width": 32,
                    },
                    "mace_time_low": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "Low 32 bits of the 64 bit timestamp set by MACE. Units of nanoseconds. This is used as the timing master when track_select = 0.",
                        "start": 3,
                        "step": 1,
                        "stop": 4,
                        "width": 32,
                    },
                    "track_select": {
                        "access_mode": "RW",
                        "bit_offset": 0,
                        "default": 0,
                        "description": "0 to track time as set by MACE, 1 to track time coming from timing packets on the 100GE interface.",
                        "start": 0,
                        "step": 1,
                        "stop": 1,
                        "width": 1,
                    },
                },
                "start": 0,
                "step": 8,
                "stop": 8,
                "type": "REG",
            }
        },
        "start": 196608,
        "step": 8,
        "stop": 196616,
    },
    "vitis_shared": {
        "slaves": {
            "vitis_shared": {
                "fields": {
                    "data": {
                        "access_mode": "RW",
                        "bit_offset": 32,
                        "default": 0,
                        "description": "128 Kbyte page to access the registers. Copy data to/from this memory using the CDMA core.",
                        "start": 0,
                        "step": 1,
                        "stop": 32768,
                        "width": 32,
                    }
                },
                "start": 0,
                "step": 32768,
                "stop": 32768,
                "type": "RAM",
            }
        },
        "start": 32768,
        "step": 32768,
        "stop": 65536,
    },
}
